import numpy as np
from PIL import Image
from scipy import misc
from constants import APS, PS, classn, fea_len, WeightDecay, BatchSize, Epochs, MinProb, XenWei, CmWei

AgeRan = [[0,2], [4,6], [8,13], [15,20], [25,32], [38,43], [48,53], [60,100]];
AgeDiv = [      3,     7,     14,     22.5,     35,     45.5,    56.5];

def in_age_ran(age):
    for ix in range(len(AgeRan)):
        if (AgeRan[ix][0] <= age) and (age <= AgeRan[ix][1]):
            return True;
    return False;

def closest_ran(age):
    for ix in range(len(AgeDiv)):
        if age <= AgeDiv[ix]:
            return ix;
    return len(AgeDiv);

def im_square(im):
    if len(im.shape) <= 2:
        rgb = np.zeros((im.shape[0], im.shape[1], 3), dtype=np.uint8);
        rgb[:, :, 0] = im; rgb[:, :, 1] = im; rgb[:, :, 2] = im; im = rgb;

    x0 = 0;
    x1 = im.shape[1];
    y0 = 0;
    y1 = im.shape[0];

    if (y1-y0) < (x1-x0):
        x_len = y1 - y0;
        x0 = int(round(x0 + (x1-x0-x_len)/2.0));
        x1 = int(round(x1 - (x1-x0-x_len)/2.0));
    else:
        y_len = x1 - x0;
        y0 = int(round(y0 + (y1-y0-y_len)/2.0));
        y1 = int(round(y1 - (y1-y0-y_len)/2.0));
    im = np.array(Image.fromarray(im).crop((x0, y0, x1, y1)));
    im = misc.imresize(im, (APS, APS));
    return im;

# this function loads Adience images and labels
def load_data(image_list):
    X = np.zeros((100000, 3, APS, APS), dtype=np.float32);
    y = np.zeros((100000, classn), dtype=np.float32);
    ind = 0;
    for image_f in image_list:
        with open(image_f) as f:
            for line in f:
                (image_name, age, vari) = line.split('\t');
                if not in_age_ran(float(age)):
                    continue;
                im = im_square(misc.imread('adience/' + image_name));
                X[ind, :, :, :] = im.transpose();
                y[ind, closest_ran(float(age))] = 1;
                ind += 1;
                if (ind % 1000) == 0:
                    print ind;

    X = X[0:ind];
    y = y[0:ind];

    print "Data Loaded", X.shape, y.shape;
    return [X, y];

